*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE005B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (10 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 5
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,KXM1,KXM2,KXM3,KXM4,KXM1M2,KXM3M4,YYY
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.D0
      KXM1= 5*X-1.D0
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N') THEN
         KXM2=KXM1-1
         KXM3=KXM2-1
         KXM4=KXM3-1
         KXM1M2=KXM1*KXM2
         KXM3M4=KXM3*KXM4
         YYY=1.D0/24
         P(1)=    YYY*X*KXM1M2*KXM3M4
         P(2)=   -YYY  *KXM1M2*KXM3M4*XM1
         P(3)=-25*YYY*X*KXM1M2*KXM3  *XM1
         P(4)= 50*YYY*X*KXM1M2  *KXM4*XM1
         P(5)=-50*YYY*X*KXM1  *KXM3M4*XM1
         P(6)= 25*YYY*X  *KXM2*KXM3M4*XM1
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         YYY=3125.D0/24
         DP(1)= 1D0+(-125D0/6+(109.375D0+(-625D0/3+YYY*X)*X)*X)*X
         DP(2)=-137D0/12+(93.75D0+(-265.625D0+(312.5D0-YYY*X)*X)*X)*X
         DP(3)=-25D0/4+(1525D0/12+(-640.625D0+(6875D0/6-5*YYY*X)*X)*X)*X
         DP(4)= 50D0/3+(-325+(1531.25D0+(-2500+10*YYY*X)*X)*X)*X
         DP(5)=-25D0+(2675D0/6+(-1843.75D0+(8125D0/3-10*YYY*X)*X)*X)*X
         DP(6)= 25D0+(-1925D0/6+(1109.375D0+(-4375D0/3+5*YYY*X)*X)*X)*X
      ENDIF
*-----------------------------------------------------------------------
      END
