*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE006B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (10 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 6
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,DXM1,TXM1,TXM2,TXM1M2,KXM1,KXM4,KXM5,KXM1M5
     &                ,XM1DXM,YYY
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      DXM1= 2*X-1.
      KXM1= 6*X-1.
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N') THEN
         XM1DXM=XM1*DXM1
         TXM1=3*X-1
         TXM2=TXM1-1
         TXM1M2=TXM1*TXM2
         KXM5=KXM1-4
         KXM1M5=KXM1*KXM5
         P(1)= 0.1D0*X  *DXM1*TXM1M2*KXM1M5
         P(2)= 0.1D0  *XM1DXM*TXM1M2*KXM1M5
         P(7)=-3.6D0*X*XM1DXM*TXM1M2  *KXM5
         P(6)= 4.5D0*X*XM1DXM  *TXM2*KXM1M5
         P(5)=-4.0D0*X*XM1   *TXM1M2*KXM1M5
         P(4)= 4.5D0*X*XM1DXM*TXM1  *KXM1M5
         P(3)=-3.6D0*X*XM1DXM*TXM1M2*KXM1
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         DP(1)=0.1D0*(12*X-5)*(2+(-50+(285+(-540+324*X)*X)*X)*X)
         DP(2)=0.1D0*(12*X-7)*(21+(-196+(609+(-756+324*X)*X)*X)*X)
         DP(7)=36+(-626.4D0+(3132+(-6696+(6480-2332.8D0*X)*X)*X)*X)*X
         DP(6)=-45+(1053+(-6223.5D0+(14796+(-15390+5832*X)*X)*X)*X)*X
         DP(5)=-8*DXM1*(1+18*XM1*X)*(5+27*XM1*X)
         DP(4)=-22.5D0+(594+(-4144.5D0+(11556+(-13770+5832*X)*X)*X)*X)*X
         DP(3)=7.2D0+(-194.4D0+(1404+(-4104+(5184-2332.8D0*X)*X)*X)*X)*X
      ENDIF
*-----------------------------------------------------------------------
      END
