*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE007B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (10 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 7
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,XXM1,KXM1,KXM2,KXM3,KXM4,KXM5,KXM6
     &                ,KXM1M2,KXM3M4,KXM5M6,YYY
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      XXM1 = X*XM1
      KXM1= 7*X-1.
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N') THEN
          KXM2=KXM1-1
          KXM3=KXM2-1
          KXM4=KXM3-1
          KXM5=KXM4-1
          KXM6=KXM5-1
          KXM1M2=KXM1*KXM2
          KXM3M4=KXM3*KXM4
          KXM5M6=KXM5*KXM6
          YYY=1D0/720
          P(2)=    -YYY* XM1*KXM1M2*KXM3M4*KXM5M6
          P(1)=     YYY*X   *KXM1M2*KXM3M4*KXM5M6
          P(8)=  49*YYY*XXM1  *KXM2*KXM3M4*KXM5M6
          P(7)=-147*YYY*XXM1*KXM1  *KXM3M4*KXM5M6
          P(6)= 245*YYY*XXM1*KXM1M2  *KXM4*KXM5M6
          P(5)=-245*YYY*XXM1*KXM1M2*KXM3  *KXM5M6
          P(4)= 147*YYY*XXM1*KXM1M2*KXM3M4  *KXM6
          P(3)= -49*YYY*XXM1*KXM1M2*KXM3M4*KXM5
       ENDIF
*         Derivees premieres
       IF (KELFCT(2:2).NE.'N') THEN
          DP(2)=-18.15D0+(22981D0/90+(-331681D0/240+(33614D0/9
     &         +(-386561D0/72+(117649D0/30-823543D0/720
     &         *X)*X)*X)*X)*X)*X
          DP(1)=1+(-34.3D0+(9947D0/30+(-16807D0/12+(420175D0/144
     &         +(-2941.225D0+823543D0/720*X)*X)*X)*X)*X)*X
          DP(8)=49+(-1092.7D0+(109417D0/15+(-22209.25D0
     &         +(4958065D0/144+(-26471.025D0+5764801D0/720
     &         *X)*X)*X)*X)*X)*X
          DP(7)=-73.5D0+(2153.55D0+(-16845.5875D0+(170471D0/3
     &         +(-94539.375D0+(76471.85D0-5764801D0/240
     &          *X)*X)*X)*X)*X)*X
          DP(6)=245D0/3+(-46501D0/18+(133427D0/6+(-2926819D0/36
     &         +(20756645D0/144+(-2941225D0/24+5764801D0/144
     &         *X)*X)*X)*X)*X)*X
          DP(5)=-61.25D0+(2009+(-872935D0/48+(211288D0/3
     &         +(-9495955D0/72+(117649-5764801D0/144
     &         *X)*X)*X)*X)*X)*X
          DP(4)=29.4D0+(-984.9D0+(9192.4D0+(-444185D0/12
     &         +(72480.1875D0+(-67648.175D0+5764801D0/240
     &         *X)*X)*X)*X)*X)*X
          DP(3)=-49D0/6+(49931D0/180+(-634207D0/240+(98441D0/9
     &         +(-1596665D0/72+(1294139D0/60-5764801D0/720
     &         *X)*X)*X)*X)*X)*X
         ENDIF
         END
