*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE008B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (05 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 8
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,DXM1,XM1DXM,QXM1,QXM3,QXM1M3,KXM1,KXM3,KXM5
     &                ,KXM7,KXM1M3,KXM5M7,YYY
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      KXM1= 8*X-1.
*     Fonctions de base
      YYY=1D0/315
      IF (KELFCT(1:1).NE.'N') THEN
         DXM1=2*X-1
         XM1DXM=X*XM1*DXM1
         QXM1=4*X-1
         QXM3=QXM1-2
         QXM1M3=QXM1*QXM3
         KXM3=KXM1-2
         KXM5=KXM3-2
         KXM7=KXM5-2
         KXM1M3=KXM1*KXM3
         KXM5M7=KXM5*KXM7
         P(2)=     YYY*DXM1*QXM1M3*KXM1M3*KXM5M7*XM1
         P(1)=     YYY*X *DXM1*QXM1M3*KXM1M3*KXM5M7
         P(9)= -64*YYY*XM1DXM*QXM1M3*KXM3*KXM5M7
         P(8)= 112*YYY*XM1DXM*  QXM3*KXM1M3*KXM5M7
         P(7)=-448*YYY*XM1DXM*QXM1M3*KXM1*KXM5M7
         P(6)= 140*YYY*X*XM1*QXM1M3*KXM1M3*KXM5M7
         P(5)=-448*YYY*XM1DXM*QXM1M3*KXM1M3*KXM7
         P(4)= 112*YYY*XM1DXM*QXM1  *KXM1M3*KXM5M7
         P(3)= -64*YYY*XM1DXM*QXM1M3*KXM1M3*KXM5
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         DP(2)=YYY*(16*X-9)*(761+(-11772+(68784+(-196992
     &        +(294912+(-221184+65536*X)*X)*X)*X)*X)*X)
         DP(1)=YYY*(16*X-7)*(45+(-1764+(18480+(-81536
     &        +(172032+(-172032+65536*X)*X)*X)*X)*X)*X)
         DP(9)=64+(-61568D0/35+(44672D0/3+(-2695168D0/45
     &        +(1177600D0/9+(-2392064D0/15+(917504D0/9-8388608D0/315
     &          *X)*X)*X)*X)*X)*X)*X
         DP(8)=-112+(3974.4D0+(-587296D0/15+(7827968D0/45
     &        +(-3665920D0/9+(7831552D0/15+(-15597568D0/45
     &        +4194304D0/45*X)*X)*X)*X)*X)*X)*X
         DP(7)=448D0/3+(-256384D0/45+(61209.6D0+(-4390912D0/15
     &        +(727040+(-976486.4D0+(10092544D0/15-8388608D0/45
     &          *X)*X)*X)*X)*X)*X)*X
         DP(6)=4D0/9*(2*X-1)*(315+(-11808+(116256+(-471040
     &        +(890880+(-786432+262144*X)*X)*X)*X)*X)*X)
         DP(5)=448D0/5+(-3609.6D0+(626048D0/15+(-9773056D0/45
     &        +(5285888D0/9+(-12812288D0/15+(28442624D0/45
     &         -8388608D0/45*X)*X)*X)*X)*X)*X)*X
         DP(4)=-112D0/3+(68576D0/45+(-17952D0+(1435136D0/15
     &        +(-266240D0+(399769.6D0+(-917504D0/3+4194304D0/45
     &          *X)*X)*X)*X)*X)*X)*X
         DP(3)=64D0/7+(-13184D0/35+(67456D0/15+(-1097728D0/45
     &        +(624640D0/9+(-1605632D0/15+(3801088D0/45-8388608D0/315
     &          *X)*X)*X)*X)*X)*X)*X
      ENDIF
      END
