*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE009B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (05 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 9
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,TXM1,TXM2,KXM1,KXM2,KXM4,KXM5,KXM7,KXM8
     &                ,KXM1M2,KXM4M5,KXM7M8,YYY,ZZ1,ZZ2
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      KXM1= 9*X-1.
*     Fonctions de base
      YYY=1D0/4480
      IF (KELFCT(1:1).NE.'N') THEN
         TXM1=3*X-1
         TXM2=TXM1-1
         KXM2=KXM1-1
         KXM4=KXM1-3
         KXM5=KXM1-4
         KXM7=KXM1-6
         KXM8=KXM1-7
         KXM1M2=KXM1*KXM2
         ZZ1=KXM1M2*TXM1
         KXM4M5=KXM4*KXM5
         KXM7M8=KXM7*KXM8
         ZZ2 =KXM7M8*TXM2 
         P(2) =     -YYY  *ZZ1*KXM4M5*ZZ2*XM1
         P(1) =      YYY*X*ZZ1*KXM4M5*ZZ2
         P(10)=   81*YYY*X*KXM2*TXM1*KXM4M5*ZZ2*XM1
         P(9) = -324*YYY*X*KXM1*TXM1*KXM4M5*ZZ2*XM1
         P(8) =  252*YYY*X*KXM1M2*KXM4M5*ZZ2*XM1
         P(7) =-1134*YYY*X*ZZ1*KXM5*ZZ2*XM1
         P(6) = 1134*YYY*X*ZZ1*KXM4*ZZ2*XM1
         P(5) = -252*YYY*X*ZZ1*KXM4M5*KXM7M8*XM1
         P(4) =  324*YYY*X*ZZ1*KXM4M5*TXM2*KXM8*XM1
         P(3) =  -81*YYY*X*ZZ1*KXM4M5*TXM2*KXM7*XM1
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         DP(2)=-7129D0/280+(58635D0/112+(-122121D0/28+(623295D0/32
     &         +(-6589431D0/128+(2657205D0/32+(-5137263D0/64
     &         +(4782969D0/112-43046721D0/4480*X)*X)*X)*X)*X)*X)*X)*X
         DP(1)=1+(-6849D0/140+(797337D0/1120+(-194643D0/40
     &         +(2337903D0/128+(-1594323D0/40+(16120377D0/320
     &         +(-4782969D0/140+43046721D0/4480*X)*X)*X)*X)*X)*X)*X)*X
         DP(10)=81+(-373329D0/140+(30921993D0/1120+(-5589243D0/40
     &         +(51221727D0/128+(-13640319D0/20+(219485133D0/320
     &         +(-52612659D0/140+387420489D0/4480*X)*X)*X)*X)*X)*X)*X)*X
         DP(9)=-162+(475389D0/70+(-45570519D0/560+(18152829D0/40
     &         +(-44529507D0/32+(99733761D0/40+(-26040609D0/10
     &         +(205667667D0/140-387420489D0/1120*X)*X)*X)*X)*X)*X)*X)*X
         DP(8)=252+(-56601D0/5+(5878089D0/40+(-8776431D0/10
     &         +(91020753D0/32+(-213107841D0/40+(115322697D0/20
     &         +(-33480783D0/10+129140163D0/160*X)*X)*X)*X)*X)*X)*X)*X
         DP(7)=-567D0/2+(526419D0/40+(-14257053D0/80+(89119521D0/80
     &         +(-241241409D0/64+(586888011D0/80+(-1313190711D0/160
     &         +(196101729D0/40-387420489D0/320*X)*X)*X)*X)*X)*X)*X)*X
         DP(6)=1134D0/5+(-21465D0/2+(2386017D0/16+(-3844017D0/4
     &         +(215023653D0/64+(-54029835D0/8+(249245829D0/32
     &         +(-4782969+387420489D0/320*X)*X)*X)*X)*X)*X)*X)*X
         DP(5)=-126+(60381D0/10+(-6828867D0/80+(22480173D0/40
     &         +(-64448703D0/32+(166341033D0/40+(-197164611D0/40
     &         +(62178597D0/20-129140163D0/160*X)*X)*X)*X)*X)*X)*X)*X
         DP(4)=324D0/7+(-78327D0/35+(8968887D0/280+(-2142531D0/10
     &         +(25043337D0/32+(-66075831D0/40+(80247591D0/40
     &         +(-90876411D0/70+387420489D0/1120*X)*X)*X)*X)*X)*X)*X)*X
         DP(3)=-81D0/8+(275967D0/560+(-3986901D0/560+(7712091D0/160
     &         +(-22878207D0/128+(61470009D0/160+(-152523567D0/320
     &         +(176969853D0/560-387420489D0/4480*X)*X)*X)*X)*X)*X)*X)*X
      ENDIF
      END
