*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE106B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin (12 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 6
* pour l'interpolation de Lagrange aux points de Gauss-Lobatto
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,XXM1,XMHALF,A,CGALO7,CGALO6
*-----------------------------------------------------------------------
*        Element de Lagrange P6 aux 7 points de Gauss-Lobatto
*        ranges par abcsisses croissantes selon l'ordre 2 7 6 5 4 3 1
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      XXM1= X*XM1
      XMHALF=X-.5D0
      CGALO7 = .8488805186071653506D-1
      CGALO6 = .2655756032646428931D0
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N') THEN
         A=(X-CGALO7)*(XM1+CGALO7)*(X-CGALO6)*(XM1+CGALO6)
         P(1)= 132*A*X*XMHALF
         P(2)= 132*A*XM1*XMHALF
         P(5)=-422.4D0*A*XXM1

         A=-318.26366118956532019D0*XXM1*XMHALF*(X-CGALO6)*(XM1+CGALO6)
         P(3)=A*(X-CGALO7)
         P(7)=A*(XM1+CGALO7)
     
         A= 397.46366118956532019D0*XXM1*XMHALF*(X-CGALO7)*(XM1+CGALO7)
         P(4)=A*(X-CGALO6)
         P(6)=A*(XM1+CGALO6)
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         DP(1)=792*(X-.34578939918215091528D-1)
     &        *(X-.17348032077169572308D0)*(X-.3898863870655193282D0)
     &        *(X-.63433347263088677274D0)*(X-.85105421294701641775D0)
         DP(2)=792*(X-.14894578705298358193D0)
     &        *(X-.3656665273691132265D0)*(X-.61011361293448067718D0)
     &        *(X-.82651967922830426771D0)*(X-.96542106008178491335D0)
         DP(5)=-2534.4D0*(X-.35475848121550249035D-1)
     &        *(X-.18000135859128224958D0)*XMHALF
     &        *(X-.81999864140871774785D0)*(X-.96452415187844975303D0)

         DP(3)=-1909.5819671373919212D0*(XM1+CGALO7)
     &        *(X-.34658406041298907352D-1)*(X-.17395390228058738328D0)
     &        *(X-.3913918776568974474D0)*(X-.63895724243252990957D0)
         DP(7)=-1909.5819671373919211D0*(X-CGALO7)
     &        *(X-.36104275756747009098D0)*(X-.60860812234310255031D0)
     &        *(X-.82604609771941261923D0)*(X-.96534159395870109192D0)
     
         DP(4)=2384.7819671373919212D0*(XM1+CGALO6)
     &        *(X-.34892859593998878685D-1)*(X-.17545078405894771115D0)
     &        *(X-.3971974022300850741D0)*(X-.96268089343548030783D0)
         DP(6)=2384.7819671373919211D0*(X-CGALO6)
     &        *(X-.37319106564519692799D-1)*(X-.60280259776991492556D0)
     &        *(X-.82454921594105229191D0)*(X-.96510714040600111899D0)
      ENDIF
*-----------------------------------------------------------------------
      END
